/* Copyright (c) 2000-2001 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;
var availInterps = [];
//---- functions
var phpAppInfoEx = null;
var prefExecutable = null;

/* Functions Related to pref-phpini.xul */
function PrefPhp_OnLoad()  {
    var tag = 'chrome://jaguar/content/pref/pref-php.xul';
    phpAppInfoEx = Components.classes["@activestate.com/koPHPInfoInstance;1"].
            createInstance(Components.interfaces.koIPHPInfoEx);

    if (parent.hPrefWindow.prefset.hasStringPref('phpDefaultInterpreter') &&
        parent.hPrefWindow.prefset.getStringPref('phpDefaultInterpreter'))
        prefExecutable = parent.hPrefWindow.prefset.getStringPref('phpDefaultInterpreter');
    else
        prefExecutable = '';
    PrefPhp_PopulatePHPInterps();

    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefPhp_OkCallback, tag);
    // find the available PHP interps
    PrefPhp_DebuggerConfiguredMessage();
}

function _warnIni()
{
    // XXX I'll come back to this later.  Shane
    //dump("_warnIni\n");
    //var txt = document.getElementById('iniExplain');
    //var text = "WARNING: Changing the executable may require changing your INI path.";
    //if (txt.childNodes.length > 0) {
    //    txt.removeChild(txt.childNodes[0]);
    //}
    //txt.appendChild(document.createTextNode(text));
}

var _lastIniPath = null;
var _lastInterpreterPath = null;

function PrefPhp_DebuggerConfiguredMessage()
{
    var txt = document.getElementById('debugger-configured-msg');
    var ini = document.getElementById('phpConfigFile').value;
    var availInterpList = document.getElementById('phpDefaultInterpreter');
    var interpreter = availInterpList.value;
    if (availInterpList.selectedItem && typeof(availInterpList.selectedItem.value) != 'undefined') {
        interpreter = availInterpList.selectedItem.value;
    }
    if (!interpreter && availInterps.length > 1) {
        interpreter = availInterps[1];
    }

    if (ini == _lastIniPath && interpreter == _lastInterpreterPath)
        return;

    _lastIniPath = ini;
    _lastInterpreterPath = interpreter;

    phpAppInfoEx.executablePath = interpreter;
    phpAppInfoEx.cfg_file_path = ini;
    var text;
    if (phpAppInfoEx.isDebuggerExtensionLoadable) {
        text = "PHP is configured for debugging.  You can use the "+
            "configuration wizard to reconfigure if you have changed "+
            "your primary ini file.";
    } else {
        text = "WARNING!  PHP is not configured for debugging.  You can use the "+
            "configuration wizard to configure PHP for debugging.";
    }
    if (txt.childNodes.length > 0) {
        txt.removeChild(txt.childNodes[0]);
    }
    txt.appendChild(document.createTextNode(text));
}

function PrefPhp_OkCallback(prefset)
{
    var ok = true;

    // ensure that the default PHP interpreter is valid
    var defaultInterp = prefset.getStringPref("phpDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            alert("No PHP interpreter could be found at '" + defaultInterp +
                  "'. You must make another selection for the default " +
                  "PHP interpreter.\n");
            ok = false;
            document.getElementById("phpDefaultInterpreter").focus();
        }
    }

    return ok;
}

function PrefPhp_SelectInterp()
{
    if (! _findingInterps) {
        // Load the default interpeter textfield with the selection
        var listbox = document.getElementById("avail-interp-list");
        var defaultInterp = document.getElementById("phpDefaultInterpreter");
        defaultInterp.value = listbox.selectedItem.getAttribute('label');
    }
    _warnIni();
    PrefPhp_DebuggerConfiguredMessage();
}

// Populate the (tree) list of available PHP interpreters on the current
// system.
function PrefPhp_PopulatePHPInterps()
{
    var availInterpList = document.getElementById("phpDefaultInterpreter");

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    availInterpList.removeAllItems();
    availInterpList.appendItem("Finding available PHP interpreters...");

    // get a list of installed PHP interpreters
    var numFound = new Object();
    availInterps = phpAppInfoEx.FindInstallationExecutables(numFound);

    availInterpList.removeAllItems();
    availInterpList.appendItem("Find on Path",'');

    var found = false;
    var item = null;
    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("no-avail-interps-message").removeAttribute("collapsed");
    } else {
        for (var i = 0; i < availInterps.length; i++) {
            item = availInterpList.appendItem(availInterps[i],availInterps[i]);
            if (availInterps[i] == prefExecutable) {
                availInterpList.selectedItem = item;
                found = true;
            }
        }
    }
    if (!found && prefExecutable) {
        availInterpList.selectedItem =
            availInterpList.appendItem(prefExecutable,prefExecutable);
    }
    _findingInterps = false;
}

/* Functions Related to pref-phpini.xul */

function PrefPhpIni_OnLoad()  {
    var tag = 'chrome://jaguar/content/pref/pref-phpini.xul';
    parent.initPanel(tag);
    parent.registerOKCallbackFunc(PrefPhpIni_OkCallback, tag);

}

function PrefPhpIni_OkCallback(prefset)
{
    //...
    return true;
}

function PrefPhp_SelectIni() {
    PrefPhp_DebuggerConfiguredMessage();
}

function loadIniFile() {
    var current = document.getElementById("phpConfigFile").value;
    var path = filepicker_openFile(null, current, null, "INI", ["INI", "All"]);
    if (path != null) {
        document.getElementById("phpConfigFile").value = path;
    }
    PrefPhp_DebuggerConfiguredMessage();
}

function loadPHPExecutable() {
    var path = filepicker_openExeFile();
    if (path != null) {
        var availInterpList = document.getElementById("phpDefaultInterpreter");
        availInterpList.selectedItem = availInterpList.appendItem(path,path);
        _warnIni();
    }
}


function wizardConfigurePHP() {
    // get selected php and ini dirs
    var info = {};
    var availInterpList = document.getElementById("phpDefaultInterpreter");
    info.ini = document.getElementById('phpConfigFile').value;
    info.interpreter = availInterpList.value;
    if (availInterpList.selectedItem && typeof(availInterpList.selectedItem.value) != 'undefined') {
        info.interpreter = availInterpList.selectedItem.value;
    }
    info.ok = false;
    window.openDialog(
            "chrome://jaguar/content/wizards/setup/php/wizard.xul",
            "komodo_wizard",
            "centerscreen,chrome,resizable,scrollbars,dialog=yes,close,modal=yes",
            info);
    if (info.ok) {
        document.getElementById('phpConfigFile').value = info.ini;
        document.getElementById('phpDefaultInterpreter').value = info.interpreter;
        availInterpList.selectedItem = availInterpList.appendItem(info.interpreter,info.interpreter);
        PrefPhp_DebuggerConfiguredMessage();
    }
}
