/* Copyright (c) 2000-2003 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

/* String interpolation query dialog (see interpolate.js)
 *
 * Used when a strings being interpolated include codes requiring that the user
 * be asked for information to place in the string.
 */

var gQueries = null;


function OnLoad()
{
    var dialog = document.getElementById("dialog-interpolationquery")
    var okButton = dialog.getButton("accept");
    var cancelButton = dialog.getButton("cancel");
    okButton.setAttribute("accesskey", "o");
    cancelButton.setAttribute("accesskey", "c");

    // Process input arguments.
    if (typeof window.arguments[0].title != "undefined" &&
        window.arguments[0].title != null) {
        window.title = window.arguments[0].title;
    } else {
        window.title = "Interpolation Query";
    }
    gQueries = window.arguments[0].queries;

    // Generate UI for the queries.
    var queryRows = document.getElementById("query-rows");

    // Special case the first one.
    // (XXX See "Gecko Sucks" comment in the XUL.)
    var q, label, textbox, row, hbox, i;
    q = gQueries[0];
    label = document.getElementById("query0-label");
    label.setAttribute("value", q.question+":");
    textbox = document.getElementById("query0-textbox");
    if (q.answer) {
        textbox.setAttribute("value", q.answer);
    } else {
        textbox.setAttribute("value", "");
    }
    textbox.setAttribute("komodo-preference-set", q.mruName+"Mru");
    textbox.setAttribute("_session", new MRUAutoCompleteSession(textbox));

    try {
        for (i = 1; i < gQueries.length; i++) {
            // Want the following XUL for each query:
            //    <row>
            //        <hbox>
            //            <label id="query0-label" value="QUESTION"
            //                   control="query0-textbox"/>
            //        </hbox>
            //        <textbox id="query0-textbox" flex="1" value="ANSWER"
            //                 onfocus="this.setSelectionRange(0,-1);"
            //                 style="min-height: 16px;"/>
            //                 type="autocomplete" maxrows="3"
            //                 komodo-preference-set="MRUNAMEMru"/>
            //    </row>
            // Plus create a new auto-complete MRU session for each.
            q = gQueries[i];

            row = document.createElement("row");

            hbox = document.createElement("hbox");
            label = document.createElement("label");
            label.setAttribute("id", "query"+i+"-label");
            label.setAttribute("value", q.question+":");
            label.setAttribute("control", "query"+i+"-textbox");
            label.setAttribute("crop", "end");
            label.setAttribute("flex", "1");
            hbox.setAttribute("align", "center");
            hbox.appendChild(label);
            row.appendChild(hbox);

            textbox = document.createElement("textbox");
            textbox.setAttribute("id", "query"+i+"-textbox");
            textbox.setAttribute("flex", "1");
            if (q.answer) {
                textbox.setAttribute("value", q.answer);
            } else {
                textbox.setAttribute("value", "");
            }
            textbox.setAttribute("onfocus", "this.setSelectionRange(0,-1);");
            textbox.setAttribute("style", "min-height: 16px;");
            textbox.setAttribute("type", "autocomplete");
            textbox.setAttribute("maxrows", "3");
            textbox.setAttribute("komodo-preference-set", q.mruName+"Mru");
            textbox.setAttribute("align", "center");
            window.setTimeout("new MRUAutoCompleteSession(document.getElementById('query"+i+"-textbox'))");
            row.appendChild(textbox);

            queryRows.appendChild(row);
        }
    } catch(ex) {
        dump("error adding interpolation query rows: "+ex+"\n");
    }

    window.sizeToContent();
    dialog.moveToAlertPosition();
}



function OK()
{
    // Store users answers to query objects.
    for (var i = 0; i < gQueries.length; i++) {
        var q = gQueries[i];
        var id = "query"+i+"-textbox";
        var queryTextbox = document.getElementById(id);
        if (queryTextbox.value) {
            q.answer = queryTextbox.value;
            MRU_updateFromWidget(queryTextbox);
        } else {
            q.answer = "";
        }
    }

    window.arguments[0].retval = "OK";
    return true;
}


function Cancel()
{
    window.arguments[0].retval = "Cancel";
    return true;
}

